import * as MC from "@minecraft/server";

MC.world.afterEvents.entityHurt.subscribe((eventData) => {
  let entity = eventData.hurtEntity;
  const damager = eventData.damageSource.damagingEntity;
  const hand = damager.getComponent("minecraft:inventory").container.getItem(damager.selectedSlot);
  if (entity) {
    if (hand.typeId.includes("_hammer") && hand.typeId.includes("more:")) {
      entity.runCommandAsync(`tag @s add impact`);
      damager.runCommandAsync(`scoreboard players add @s attack_cooldown 0`);
      damager.runCommandAsync(`tag @e[m=c] remove impact`);
      damager.runCommandAsync(`tag @e[tag=immortal] remove impact`);
      damager.runCommandAsync(`tag @e[family=inanimate] remove impact`);
      damager.runCommandAsync(`execute as @s[scores={attack_cooldown=..0}] as @e[tag=impact] positioned ~~2~ run particle minecraft:critical_hit_emitter`);
      damager.runCommandAsync(`execute as @s[scores={attack_cooldown=..0}] as @e[tag=impact] positioned ~~1~ run particle minecraft:critical_hit_emitter`);
      damager.runCommandAsync(`execute as @s[scores={attack_cooldown=..0}] run playsound random.anvil_land @a[r=16] ~~~ 100 0.8`);
      damager.runCommandAsync(`execute as @s[scores={attack_cooldown=..0}] run effect @e[r=15,tag=impact] slowness 3 4 true`);
      damager.runCommandAsync(`execute as @s[scores={attack_cooldown=..0}] run effect @a[r=15,tag=impact] nausea 3 2 true`);
      damager.runCommandAsync(`execute as @s[scores={attack_cooldown=..0}] run effect @s slowness 1 0 true`);
      damager.runCommandAsync(`execute as @s[scores={attack_cooldown=..0}] run damage @e[tag=impact] 4 suicide entity @s`);
      damager.runCommandAsync(`execute as @s[scores={attack_cooldown=..0}] positioned as @e[tag=impact] run summon add:knockback`);
      damager.runCommandAsync(`tag @e remove impact`);
      damager.runCommandAsync(`scoreboard players set @s attack_cooldown 32`);
      damager.runCommandAsync(`tag @s[scores={attack_cooldown=..32}] add 32ticks`);
    }
  }
});