import {
  system,
  world
} from "@minecraft/server";

world.afterEvents.playerInteractWithBlock.subscribe((eventData) => {
  let player = eventData.player;
  let block = eventData.block;
  let item = eventData.itemStack;
  let inventory = player.getComponent("minecraft:inventory").container;
  let durability = item.getComponent("minecraft:durability");
  let crops = [
    "minecraft:wheat",
    "minecraft:carrots",
    "minecraft:potatoes",
    "minecraft:beetroot",
    "minecraft:nether_wart"
  ];
  if (crops.includes(block.typeId) && item.typeId.includes("hoe")) {
    player.runCommandAsync(`execute positioned ${block.location.x} ${block.location.y} ${block.location.z} if block ~~~ wheat ["growth"=7] run setblock ~~~ wheat destroy`);
    player.runCommandAsync(`execute positioned ${block.location.x} ${block.location.y} ${block.location.z} if block ~~~ carrots ["growth"=7] run setblock ~~~ carrots destroy`);
    player.runCommandAsync(`execute positioned ${block.location.x} ${block.location.y} ${block.location.z} if block ~~~ potatoes ["growth"=7] run setblock ~~~ potatoes destroy`);
    player.runCommandAsync(`execute positioned ${block.location.x} ${block.location.y} ${block.location.z} if block ~~~ beetroot ["growth"=7] run setblock ~~~ beetroot destroy`);
    player.runCommandAsync(`execute positioned ${block.location.x} ${block.location.y} ${block.location.z} if block ~~~ nether_wart ["growth"=3] run setblock ~~~ nether_wart destroy`);
    if (player.hasTag("durability.damage")) {
      durability.damage++
      inventory.setItem(player.selectedSlot, item);
      if (durability.damage == durability.maxDurability) {
        player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
        player.runCommandAsync(`playsound random.break @s`);
      }
    }
  };
  if (crops.includes(block.typeId) && item.typeId.includes("scythe")) {
    for (let x = -1; x <= 1; x++) {
      for (let z = -1; z <= 1; z++) {
        player.runCommandAsync(`execute positioned ${block.location.x + x} ${block.location.y} ${block.location.z + z} if block ~~~ wheat ["growth"=7] run setblock ~~~ wheat destroy`);
        player.runCommandAsync(`execute positioned ${block.location.x + x} ${block.location.y} ${block.location.z + z} if block ~~~ carrots ["growth"=7] run setblock ~~~ carrots destroy`);
        player.runCommandAsync(`execute positioned ${block.location.x + x} ${block.location.y} ${block.location.z + z} if block ~~~ potatoes ["growth"=7] run setblock ~~~ potatoes destroy`);
        player.runCommandAsync(`execute positioned ${block.location.x + x} ${block.location.y} ${block.location.z + z} if block ~~~ beetroot ["growth"=7] run setblock ~~~ beetroot destroy`);
        player.runCommandAsync(`execute positioned ${block.location.x + x} ${block.location.y} ${block.location.z + z} if block ~~~ nether_wart ["growth"=3] run setblock ~~~ nether_wart destroy`);
        player.runCommandAsync(`replaceitem entity @s[hasitem={item=${item.typeId.includes("scythe")},data=${durability.maxDurability}}] slot.weapon.mainhand 0 air`);
        if (player.hasTag("durability.damage")) {
          durability.damage++
          inventory.setItem(player.selectedSlot, item);
          if (durability.damage == durability.maxDurability) {
            player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
            player.runCommandAsync(`playsound random.break @s`);
          }
        }
      }
    }
  }
});